<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
                  <el-form-item label="统一社会信用代码" prop="uniCode" label-width="200">
                    <el-input
                        v-model="queryParams.uniCode"
                        placeholder="请输入统一社会信用代码"
                        clearable
                        @keyup.enter="handleQuery"
                    />
                  </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="warning"
            plain
            icon="Download"
            @click="handleExport"
            :disabled="!xcrInstallmentPaymentList.length"
            v-hasPermi="['basicData:xcrInstallmentPayment:export']"
        >导出
        </el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="xcrInstallmentPaymentList" height="650" @selection-change="handleSelectionChange">
        <el-table-column label="统一社会信用代码" align="center" prop="uniCode" width="200"/>
                  <el-table-column label="实缴ID，主键" align="center" prop="PAID" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="投资人标识" align="center" prop="INVID" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="本期实缴出资额，单位：万元" align="center" prop="ACCONAM" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="出资方式" align="center" prop="CONFORM" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="出资方式" align="center" prop="conformCn" :show-overflow-tooltip='true' width="150"/>
              <el-table-column label="出资日期" align="center" prop="CONDATE" width="180">
                <template #default="scope">
                  <span>{{ parseTime(scope.row.CONDATE, '{y}-{m}-{d}') }}</span>
                </template>
              </el-table-column>
                  <el-table-column label="本期实缴出资额折万美元，单位：万美元" align="center" prop="CURACTCONAMUSD" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="币种" align="center" prop="CURRENCY" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="出资来源，1-境内|2-境外" align="center" prop="CONSOURCE" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="欠资原因" align="center" prop="POSDUEREA" :show-overflow-tooltip='true' width="150"/>
                  <el-table-column label="验资(审计)机构" align="center" prop="VERCAPORG" :show-overflow-tooltip='true' width="150"/>
              <el-table-column label="数据更新时间，数据初始化或更新时间戳" align="center" prop="sExtDatatime" width="180">
                <template #default="scope">
                  <span>{{ parseTime(scope.row.sExtDatatime, '{y}-{m}-{d}') }}</span>
                </template>
              </el-table-column>
                  <el-table-column label="ETPS_ID" align="center" prop="etpsId" :show-overflow-tooltip='true' width="150"/>
    </el-table>

    <div style="position: fixed;bottom: 20px;right: 10px;">
      <pagination
          v-show="total>0"
          :total="total"
          v-model:page="queryParams.pageNum"
          v-model:limit="queryParams.pageSize"
          @pagination="getList"
      />
    </div>

    <el-dialog :title="upload.title" v-model="upload.open" width="400px" append-to-body>
      <el-upload ref="uploadRef" :limit="1" accept=".xlsx, .xls" :headers="upload.headers"
                 :action="upload.url + '?updateSupport=' + upload.updateSupport" :disabled="upload.isUploading"
                 :on-progress="handleFileUploadProgress" :on-success="handleFileSuccess" :auto-upload="false" drag>
        <el-icon class="el-icon--upload">
          <upload-filled/>
        </el-icon>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <template #tip>
          <div class="el-upload__tip text-center">
            <span>仅允许导入xls、xlsx格式文件。</span>
          </div>
        </template>
      </el-upload>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitFileForm">确 定</el-button>
          <el-button @click="upload.open = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Payment">
  import {
    listPayment,
    getPayment,
    delPayment,
    delPaymentBatch
  } from "@/api/basicData/xcrInstallmentPayment";
  import {reactive, ref, toRaw} from "vue";
  import {getToken} from "@/utils/auth";
  import {ElMessage} from "element-plus";
  import {likeQueryMethod} from "@/utils/likeQueryMethod";

  const {proxy} = getCurrentInstance();

  const xcrInstallmentPaymentList = ref([]);
  const open = ref(false);
  const loading = ref(true);
  const showSearch = ref(true);
  const ids = ref([]);
  const single = ref(true);
  const multiple = ref(true);
  const total = ref(0);
  const title = ref("");

  const upload = reactive({
    // 是否显示弹出层（用户导入）
    open: false,
    // 弹出层标题（用户导入）
    title: '',
    // 是否禁用上传
    isUploading: false,
    // 设置上传的请求头部
    headers: {Authorization: getToken()},
    // 上传的地址
    url: import.meta.env.VITE_APP_BASE_API + '/xcrInstallmentPayment/importData'
  })
  const handleFileSuccess = (e) => {
    if (e.code == 200) {
      ElMessage({
        type: "success",
        message: e.msg
      })
      getList()
      proxy.$refs['uploadRef']?.clearFiles()
    } else {
      ElMessage({
        type: "error",
        message: e.msg
      })
      proxy.$refs['uploadRef']?.clearFiles()
    }
  }

  function submitFileForm() {
    proxy.$refs['uploadRef']?.submit();
    upload.open = false;
  }

  function handleImport() {
    upload.open = true
  }

  const data = reactive({
    form: {},
    queryParams: {
      pageNum: 1,
      pageSize: 20,
                        PAID: null,
                        INVID: null,
                        ACCONAM: null,
                        CONFORM: null,
                        conformCn: null,
                        CONDATE: null,
                        CURACTCONAMUSD: null,
                        CURRENCY: null,
                        CONSOURCE: null,
                        POSDUEREA: null,
                        VERCAPORG: null,
                        sExtDatatime: null,
                        etpsId: null,
                        uniCode: ''
    },
    rules: {
    }
  });

  const {queryParams, form, rules} = toRefs(data);

  /** 查询分期实缴信息列表 */
  function getList() {
    loading.value = true;
                                                                                              let toServerObj = likeQueryMethod('uni_code', queryParams.value.uniCode, queryParams.value.pageNum, queryParams.value.pageSize);
    listPayment(toServerObj).then(response => {
            xcrInstallmentPaymentList.value = response.records;
      total.value = response.total;
      loading.value = false;
    });
  }


  // 表单重置
  function reset() {
    form.value = {
                        xhCodeId: null,
                        PAID: null,
                        INVID: null,
                        ACCONAM: null,
                        CONFORM: null,
                        conformCn: null,
                        CONDATE: null,
                        CURACTCONAMUSD: null,
                        CURRENCY: null,
                        CONSOURCE: null,
                        POSDUEREA: null,
                        VERCAPORG: null,
                        sExtDatatime: null,
                        etpsId: null,
                        uniCode: ''
    };
    proxy.resetForm("xcrInstallmentPaymentRef");
  }

  /** 搜索按钮操作 */
  function handleQuery() {
    queryParams.value.pageNum = 1;
    getList();
  }

  /** 重置按钮操作 */
  function resetQuery() {
    proxy.resetForm("queryRef");
    handleQuery();
  }

  // 多选框选中数据
  function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.xhCodeId);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
  }


  /** 删除按钮操作 */
  async function handleDelete(row) {
    const res = await delPayment();
    if(res.code == 200){
      ElMessage({
        type:'success',
        message:'删除成功'
      })
      getList();
    }
  }
  /** 批量删除*/
  const batchDelete = (row)=>{
    const idsToS = row.xhCodeId || ids.value;
    (proxy.$modal).confirm('是否确认删除这' + idsToS.length+'条的数据项？').then(function() {
      return delPaymentBatch(toRaw(idsToS));
    }).then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    }).catch(() => {});
  }

  /** 导出按钮操作 */
  function handleExport() {
    proxy.download('basicData/xcrInstallmentPayment/export', {
      ...queryParams.value
    }, `分期实缴信息_${new Date().getTime()}.xlsx`)
  }

  getList();
</script>
